import convexHull from 'monotone-convex-hull-2d'
import type { Point } from './Point'

export function ConvexHull2D(points: Point[]): Point[]
{
  let pts = points.map(p => [p.x, p.y])
  let indexs: number[] = convexHull(pts)
  return indexs.map(i => points[i])
}
