export function UrlToBitmap(src: string)
{
  return new Promise<HTMLImageElement>((resolve) =>
  {
    let img = new Image()
    img.src = src
    img.onload = () =>
    {
      resolve(img)
    }
  })
}
